2017 杭电多校联赛第二场 1003 Maximum Sequence(单调队列)HDU 6047

Maximum Sequence

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 0    Accepted Submission(s): 0


Problem Description
Steph is extremely obsessed with “sequence problems” that are usually seen on magazines: Given the sequence 11, 23, 30, 35, what is the next number? Steph always finds them too easy for such a genius like himself until one day Klay comes up with a problem and ask him about it.

Given two integer sequences {ai} and {bi} with the same length n, you are to find the next n numbers of {ai}:  an+1a2n. Just like always, there are some restrictions on  an+1a2n: for each number  ai, you must choose a number  bk from {bi}, and it must satisfy  ai≤max{ aj-j│ bk≤j bk can’t be chosen more than once. Apparently, there are a great many possibilities, so you are required to find max{ 2nn+1ai} modulo  109+7 .

Now Steph finds it too hard to solve the problem, please help him.
 

Input
The input contains no more than 20 test cases.
For each test case, the first line consists of one integer n. The next line consists of n integers representing {ai}. And the third line consists of n integers representing {bi}.
1≤n≤250000, n≤a_i≤1500000, 1≤b_i≤n.
 

Output
For each test case, print the answer on one line: max{ 2nn+1ai} modulo  109+7。
 

Sample Input

4 8 11 8 5 3 1 4 2
 

Sample Output

27
Hint
For the first sample: 1. Choose 2 from {bi}, then a_2…a_4 are available for a_5, and you can let a_5=a_2-2=9;

2. Choose 1 from {bi}, then a_1…a_5 are available for a_6, and you can let a_6=a_2-2=9;

题目大意:

b序列表示a[ b[i] ]可以用多少次

解题思路:

由样例举例

8  11  8  5

↓  减去i

7  9  5  1

↓ 因为b数组

           I =    1  2  3  4

7  9  5  1

可以使用的次数  1  1  1  1

↓ 因为7<9

I =   1  2  3  4

7  9  5  1

可以使用的次数  0  2  1  1

I =    2  3  4  5

  9  5  1  9-i

可以使用的次数   1  1  1  0

ans = ans + 9

↓ 因为9 - i = 4 >1

I =    2  3  4  5

  9  5  1  4

可以使用的次数   1  1  0  1

由此下去 ans = 9 + 9 + 5 + 4

AC代码

#include 
#include 
#include 
using namespace std;
int a[500004],b[500004];
int n;
long long  modx=1e9+7;
int main()
{
    while(~scanf("%d",&n))
    {
        //memset(a,0,sizeof(a));
        //memset(b,0,sizeof(b));
        int k;
        for(int i=1;i<=n;i++)
        {
            a[i]=0;
            b[i]=0;
            scanf("%d",&a[i]);
            a[i]=a[i]-i;
        } 
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&k);
            b[k]++; 
        }
        int yu=a[n],yi=n;
        for(int i=n-1;i>=1;i--)
        {
            if(a[i]0)
            {
                l++;
                a[l]=a[i]-l;
                b[l]=1;
                b[i]--;
                yu=a[l];
                yi=l;
                for(int j=l-1;j>=1;j--)
                {
                    if(a[j]


你可能感兴趣的:(2017多校联赛,比赛,2017多校联赛,杭电,单调栈)